#ifndef _DECL_CommLB_H_
#define _DECL_CommLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group CommLB: CentralLB{
void CommLB(void);
};
 */
class CommLB;
class CProxy_CommLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_CommLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_CommLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    CommLB* ckLocalBranch(void) {
      return (CommLB *) CkLocalBranch(_ck_gid);
    }
    static CommLB* ckLocalBranch(CkGroupID gID) {
      return (CommLB *) CkLocalBranch(gID);
    }
/* DECLS: void CommLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_CommLB(int retEP, CkChareID *cid);
    CProxy_CommLB(void);
    static int  __idx_CommLB_void;
    static int  ckIdx_CommLB(void) { return __idx_CommLB_void; }
    static void _call_CommLB_void(void* msg, CommLB* obj);
};

extern void _registerCommLB(void);
#endif
